import * as React from 'react';
import { Feature } from '@common-stack/client-react';
import { Files, Editors } from '@files-stack/client-react';
import { reducers, setRootPath } from '@files-stack/client-state';
import {
    resolvers, defaults, editorResolvers, schema, dataIdFromObject,
    modelContentChangeEpic, modelSaveEpic, editorSchema,
} from '@files-stack/client-state';
import { merge } from 'lodash';

const actionFunctions = [setRootPath];

export default new Feature({
    leftMainPanelItems: { files: <Files /> },
    middleMainPanelItems: { editors: <Editors /> },
    middleMainPanelItemsProps: { editors: { actionFunctions } },
    reducer: { ...reducers },
    clientStateParams: [{ resolvers: merge(resolvers, editorResolvers), defaults, typeDefs: [schema, editorSchema] }],
    dataIdFromObject,
    epic: [modelContentChangeEpic, modelSaveEpic],
});
